VERSION 1.0 CLASS
BEGIN
  MultiUse = -1  'True
  Persistable = 0  'NotPersistable
  DataBindingBehavior = 0  'vbNone
  DataSourceBehavior  = 0  'vbNone
  MTSTransactionMode  = 0  'NotAnMTSObject
END
Attribute VB_Name = "clsFileControl"
Attribute VB_GlobalNameSpace = False
Attribute VB_Creatable = True
Attribute VB_PredeclaredId = False
Attribute VB_Exposed = False
Option Explicit

Private Const BIF_RETURNONLYFSDIRS = 1
Private Const BIF_DONTGOBELOWDOMAIN = 2
Private Const BIF_STATUSTEXT = &H4
Private Const BIF_RETURNFSANCESTORS = 8
Private Const BIF_EDITBOX = &H10
Private Const BIF_VALIDATE = &H20
Private Const BIF_NEWDIALOGSTYLE = &H40
Private Const BIF_USENEWUI = BIF_NEWDIALOGSTYLE Or BIF_EDITBOX
Private Const BIF_BROWSEINCLUDEURLS = &H80
Private Const BIF_BROWSEFORCOMPUTER = &H1000
Private Const BIF_BROWSEFORPRINTER = &H2000
Private Const BIF_BROWSEINCLUDEFILES = &H4000
Private Const BIF_SHAREABLE = &H8000
Private Const MAX_PATH = 260
Private Const WM_USER = &H400&
Private Const BFFM_INITIALIZED = 1
Private Const BFFM_SELCHANGED = 2
Private Const BFFM_SETSTATUSTEXT = (WM_USER + 100)
Private Const BFFM_SETSELECTION = (WM_USER + 102)
Private Const SW_SHOWNORMAL = 1
Private Const HWND_TOPMOST = -1
Private Const HWND_NOTOPMOST = -2
Private Const SWP_NOMOVE = &H2
Private Const SWP_NOSIZE = &H1
Private Const SWP_NOACTIVATE = &H10
Private Const SWP_SHOWWINDOW = &H40
Private Const TOPMOST_FLAGS = SWP_NOMOVE Or SWP_NOSIZE
Private Const FO_MOVE As Long = &H1
Private Const FO_COPY As Long = &H2
Private Const FO_DELETE As Long = &H3
Private Const FO_RENAME As Long = &H4
Private Const FOF_MULTIDESTFILES As Long = &H1
Private Const FOF_CONFIRMMOUSE As Long = &H2
Private Const FOF_SILENT As Long = &H4
Private Const FOF_RENAMEONCOLLISION As Long = &H8
Private Const FOF_NOCONFIRMATION As Long = &H10
Private Const FOF_WANTMAPPINGHANDLE As Long = &H20
Private Const FOF_CREATEPROGRESSDLG As Long = &H0
Private Const FOF_ALLOWUNDO As Long = &H40
Private Const FOF_FILESONLY As Long = &H80
Private Const FOF_SIMPLEPROGRESS As Long = &H100
Private Const FOF_NOCONFIRMMKDIR As Long = &H200
Private Const INVALID_HANDLE_VALUE = -1

Private Type SHFILEOPSTRCT
    hWnd                    As Long
    wfunc                   As Long
    pfrom                   As String
    pto                     As String
    fFlags                  As Long
    fAnyOperationsAborted   As Long
    hNamemappings           As Long
    lpszProgressTitle       As String
End Type

Private Type FILETIME
        dwLowDateTime       As Long
        dwHighDateTime      As Long
End Type

Private Enum FILEATTRIBUTE
    FILE_ATTRIBUTE_ARCHIVE = 32         ' Ŀ ٲ , б
    FILE_ATTRIBUTE_COMPRESSED = 128     ', б
    FILE_ATTRIBUTE_DIRECTORY = 16       '͸, б
    FILE_ATTRIBUTE_HIDDEN = 2           ', б/
    FILE_ATTRIBUTE_NORMAL = 0           'ǥ
    FILE_ATTRIBUTE_READONLY = 1         'б
    FILE_ATTRIBUTE_SYSTEM = 4           'ý
End Enum

Private Type SYSTEMTIME
    wYear               As Integer
    wMonth              As Integer
    wDayOfWeek          As Integer
    wDay                As Integer
    wHour               As Integer
    wMinute             As Integer
    wSecond             As Integer
    wMilliseconds       As Integer
End Type
Private strDateTime As SYSTEMTIME

Private Type SECURITY_ATTRIBUTES
    nLength             As Long
    LPVOID              As Long
    handle              As Boolean
End Type

Private Type WIN32_FIND_DATA
    dwFileAttributes    As Long
    ftCreationTime      As FILETIME
    ftLastAccessTime    As FILETIME
    ftLastWriteTime     As FILETIME
    nFileSizeHigh       As Long
    nFileSizeLow        As Long
    dwReserved0         As Long
    dwReserved1         As Long
    cFileName           As String * MAX_PATH
    cAlternate          As String * 14
End Type

Private Type BrowseInfo
  hwndOwner             As Long
  pIDLRoot              As Long
  pszDisplayName        As Long
  lpszTitle             As Long
  ulFlags               As Long
  lpfnCallback          As Long
  lParam                As Long
  iImage                As Long
End Type




'' ------------------------------------------------------------------------------------------------------
''  INI ڵ鸵 API 
'' ------------------------------------------------------------------------------------------------------
Private Declare Function WritePrivateProfileString Lib "KERNEL32" Alias "WritePrivateProfileStringA" _
        (ByVal lpApplicationName As String, ByVal lpKeyName As Any, ByVal lpString As String, _
         ByVal lpFileName As String) As Long
         
Private Declare Function GetPrivateProfileString Lib "KERNEL32" Alias "GetPrivateProfileStringA" _
        (ByVal lpApplicationName As String, ByVal lpKeyName As Any, ByVal lpDefault As String, _
         ByVal lpReturnedString As String, ByVal nSize As Long, ByVal lpFileName As String) As Long




Private Declare Function SHFileOperation Lib "shell32.dll" Alias "SHFileOperationA" (lpFileOp As SHFILEOPSTRCT) As Long
Private Declare Function FindFirstFile Lib "KERNEL32" Alias "FindFirstFileA" (ByVal IpFileName As String, ipFindFileData As WIN32_FIND_DATA) As Long
Private Declare Function FindNextFile Lib "KERNEL32" Alias "FindNextFileA" (ByVal hFindFileName As Long, ipFindFileData As WIN32_FIND_DATA) As Long
Private Declare Function FindClose Lib "KERNEL32" (ByVal hFindFile As Long) As Long
Private Declare Sub GetSystemTime Lib "KERNEL32" (lpSystemTime As SYSTEMTIME)
Private Declare Function GetSystemMenu Lib "USER32" (ByVal hWnd As Long, ByVal bRevert As Long) As Long
Private Declare Function ShellExecute Lib "shell32.dll" Alias "ShellExecuteA" (ByVal hWnd As Long, ByVal lpOperation As String, ByVal lpFile As String, ByVal lpParameters As String, ByVal lpDirectory As String, ByVal nShowCmd As Long) As Long
Private Declare Function GetDesktopWindow Lib "USER32" () As Long
Private Declare Function SendMessage Lib "USER32" Alias "SendMessageA" (ByVal hWnd As Long, ByVal wMsg As Long, ByVal wParam As Long, ByVal lParam As String) As Long
Private Declare Function SHBrowseForFolder Lib "shell32" (lpbi As BrowseInfo) As Long
Private Declare Function CopyFile Lib "KERNEL32" Alias "CopyFileA" (ByVal lpExistingFileName As String, ByVal lpNewFileName As String, ByVal bFailIfExists As Long) As Long
Private Declare Function DeleteFile Lib "KERNEL32" Alias "DeleteFileA" (ByVal lpFileName As String) As Long
Private Declare Function RemoveDirectory Lib "KERNEL32" Alias "RemoveDirectoryA" (ByVal lpPathName As String) As Long
Private Declare Function CreateDirectoryEx Lib "KERNEL32" Alias "CreateDirectoryExA" (ByVal strDirPath As String, ByVal strNewDirectory As String, lpSecurityAttributes As SECURITY_ATTRIBUTES) As Long
Private Declare Function GetFileAttributes Lib "KERNEL32" Alias "GetFileAttributesA" (ByVal lpFileName As String) As Long
Private Declare Function SetFileAttributes Lib "KERNEL32" Alias "SetFileAttributesA" (ByVal lpFileName As String, ByVal dwFileAttributes As Long) As Long
Private Declare Function FileTimeToLocalFileTime Lib "KERNEL32" (lpFileTime As FILETIME, pLocalFileTime As FILETIME) As Long
Private Declare Function FileTimeToSystemTime Lib "KERNEL32" (lpFileTime As FILETIME, lpSystemTime As SYSTEMTIME) As Long
Private Declare Function GetDiskFreeSpaceEx Lib "KERNEL32" Alias "GetDiskFreeSpaceExA" (ByVal lpRootPathName As String, lpFreeBytesAvailableToCaller As Currency, lpTotalNumberOfBytes As Currency, lpTotalNumberOfFreeBytes As Currency) As Long

''  ѹ濡 Ǯ н Ѵ.Win2K Later ~
'' API--) SHCreateDirectoryEx hwnd, "c:\test\dird\hello\something\apiguide\", ByVal 0&
Private Declare Function SHCreateDirectoryEx Lib "shell32" Alias "SHCreateDirectoryExA" (ByVal hWnd As Long, ByVal pszPath As String, ByVal psa As Any) As Long

''  ѹ濡 Ǯ н Ѵ.WinNT 3.1 Later ~
''Private Declare Function MakeSureDirectoryPathExists Lib "imagehlp.dll" (ByVal lpPath As String) As Long

Public Event FileDelete(ByVal strFileName As String, F_Cancel As Boolean)
Public Event FileCopy(ByVal strFileName As String, F_Cancel As Boolean)

Public Function MakeDir(ByVal handle As Long, ByVal lpCreateFolderName As String) As Long
    '' Ǯн   ѹ .
    '' SHCreateDirectoryEx  API   ,  2000 ̻ O/S  ۵ϴ ݸ鿡
    '' MakeSureDirectoryPathExists API   98  O/S   ۵Ѵ.
    '' ׷  BPR      ؼ ʾ.
    
    If right(lpCreateFolderName, 1) <> "\" Then
        lpCreateFolderName = lpCreateFolderName & "\"
    End If
    MakeDir = SHCreateDirectoryEx(handle, lpCreateFolderName, ByVal 0&)
    'MakeDir = MakeSureDirectoryPathExists(lpCreateFolderName)
    If MakeDir = 0 Then MakeDir = 1
    
End Function

Public Function SHCreateDir(ByVal lpCreateFolderName As String, ByVal lpHwnd As Long) As Long
'' Ǯн   ѹ .Shell API ̿
'' WIN2K ̻ O/S  ġǸ  ּ 
'' Win2K ̻󿡼 ϴ API . 98  ʵ.
    Dim ret As Long
    
    ret = SHCreateDirectoryEx(lpHwnd, lpCreateFolderName, ByVal 0&)        '' ε θ .  ΰ ϴ ¿  õ 183 ϰ,
    SHCreateDir = ret
    
End Function

Public Function FileCount(ByVal FullPath As String) As Long
''    īƮ
    Dim FileList() As String
    
    Call SearchFile(FullPath, FileList)
    FileCount = UBound(FileList, 1) + 1
    
End Function

Public Function FolderCount(ByVal FullPath As String) As Long
''    īƮ
    Dim strDir() As String
    
    Call SearchFolder(FullPath, strDir())
    FolderCount = UBound(strDir) + 1

End Function

Public Function FileExecute(ByVal OwnerhWnd As Long, ByVal lpFile As String, lpDirectory As String, Optional ByVal lpOperation As String = vbNullString, Optional ByVal lpParameters As String = vbNullString) As Long
    
    ''   
    FileExecute = ShellExecute(OwnerhWnd, lpOperation, lpFile, lpParameters, lpDirectory, SW_SHOWNORMAL)
    
End Function

Public Function FileFound(ByVal FullPath As String, ByVal Search_Option As Long) As String
''FileFound(ϸ Ǵ ..,0-> 1->    ϵ幮ڰ)
    Dim ipFindFileData As WIN32_FIND_DATA
    Dim hFindFirst As Long
    Dim temp As String
    Dim str As String
    Dim strArray() As String
    Dim i As Integer
    Dim j As Integer
    
    On Error Resume Next
    
    hFindFirst = FindFirstFile(FullPath, ipFindFileData)               'ϪO 
    If hFindFirst <> -1 Then
        
        If Search_Option = 1 Then
            Do
                temp = StripNull(ipFindFileData.cFileName)
                If Not (temp = "." Or temp = "..") And ipFindFileData.dwFileAttributes = 32 Then
                    str = str & temp & "|"
                End If
                
            Loop While FindNextFile(hFindFirst, ipFindFileData)             ' O´.
            
        
        ElseIf Search_Option = 0 Then
            Do
                temp = StripNull(ipFindFileData.cFileName)
                If Not (temp = "." Or temp = "..") And (ipFindFileData.dwFileAttributes = 16 Or ipFindFileData.dwFileAttributes = 48) Then
                    str = str & temp & "|"
                End If
            Loop While FindNextFile(hFindFirst, ipFindFileData)             ' O´.
        End If
        Call FindClose(hFindFirst)
    End If
    
    If str <> "" Then
        str = left$(str, Len(str) - 1)
        strArray = Split(str, "|")
        For i = 0 To UBound(strArray, 1)
            For j = i + 1 To UBound(strArray, 1)
                If strArray(j) < strArray(i) Then
                    temp = strArray(j)
                    strArray(j) = strArray(i)
                    strArray(i) = temp
                End If
            Next j
        Next i
        str = ""
        For i = 0 To UBound(strArray, 1)
            str = str & strArray(i) & "|"
        Next i
        
        FileFound = left(str, Len(str) - 1)
    Else
        FileFound = ""
    End If

End Function


Public Function StripNull(ByVal strData As String) As String
'************************************************************************************************
'   Լ      :   StripNull
'   ۼ      :   
'   ۼ      :   2002.1.21
'
'   Ѽ  :   Nullڱ ڿ ߶󳻾 Ѵ.
'
'   μ        :   strData     - ߶ ڿ
'   ϰ      :   String
'************************************************************************************************
Dim pos As Long
    
    pos = InStr(strData, Chr$(0))
    
    If pos > 1 Then
        StripNull = left$(strData, pos - 1)
    ElseIf pos = 1 Then
        StripNull = ""
    Else
        StripNull = strData
    End If

End Function

Public Function StripPath(strFullPathFileName As String) As String
'**************************************************************
'Ǯо ̸ Ѵ.
'**************************************************************
'** Integers
    Dim intBackslashPosition As Integer
'** Strings
    Dim strWorkingString As String
    
    '----------------------------------------------------------
'   '齽ø ã´.  ܳ. ߿ ϳ  װ Ѵ.
    '----------------------------------------------------------
    strWorkingString = strFullPathFileName
    Do
        intBackslashPosition = InStr(1, strWorkingString, "\")
        If intBackslashPosition > 0 Then
            strWorkingString = Mid(strWorkingString, intBackslashPosition + 1)
        End If
    Loop Until intBackslashPosition = 0
    StripPath = Trim(strWorkingString)
    
End Function

Public Function GetFileLen(ByVal strFileName As String) As Long
On Error GoTo ErrorHandler

    Dim ipFindFileData As WIN32_FIND_DATA
    Dim hFindFirst As Long
    Dim temp As String
    
    hFindFirst = FindFirstFile(strFileName, ipFindFileData)               'ã 
    If hFindFirst <> -1 Then
        temp = StripNull(ipFindFileData.cFileName)
        If Not (temp = "." Or temp = "..") And (ipFindFileData.dwFileAttributes <> 16) Then
            GetFileLen = ipFindFileData.nFileSizeLow
        End If
    End If
    
    Call FindClose(hFindFirst)
    
    Exit Function
    
ErrorHandler:
    GetFileLen = 0
End Function



Public Function ValidateDir(ByVal tmpPath As String) As String

'    On Error GoTo ValidateDirErrProc


    If right(tmpPath, 1) = "\" Then
        ValidateDir = tmpPath
    Else
        If tmpPath <> vbNullString Then
            ValidateDir = tmpPath & "\"
        Else
            ValidateDir = vbNullString
        End If
    End If


    Exit Function

ValidateDirErrProc:
    MsgBox Err.Number & Err.Description

End Function

'****************************************************************************************************CS
'   Լ      :   FileReName
'   ۼ      :   
'   ۼ      :   2002.05.30
'
'   Ѽ  :
'               :
'               :
'
'   μ        :
'   ϰ      :
'****************************************************************************************************CE
Public Sub FileReName(ByVal JobDir As String, ByVal srcFileName As String, ByVal dstFileName As String)
'On Error Resume Next
    If SeekFile(JobDir & "\" & srcFileName) Then
        Name JobDir & "\" & srcFileName As JobDir & "\" & dstFileName
    End If
End Sub



Public Function ReadFile(ByVal strFileName As String, _
                         Optional F_ReadOption As Long = 0) As String
'************************************************************************************************
'   Լ      :   ReadFile
'   ۼ      :   
'   ۼ      :   2002.1.21
'   Ѽ  :    о鿩 Ʈ Ѵ.
'   μ        :   strFileName     - о ϸ
'                   F_ReadOption    - Lock...
'   ϰ      :   String
'************************************************************************************************
Dim strResult   As String
Dim strTextLine As String
Dim ptr         As String
    
On Error GoTo ReadErr:
    
    ptr = FreeFile
       
    If F_ReadOption = 0 Then
        Open strFileName For Input As #ptr
    Else
        Open strFileName For Input Lock Read As #ptr
    End If
    
    Do Until EOF(ptr)
        Line Input #ptr, strTextLine
        strResult = strResult & strTextLine & vbCrLf
    Loop
    
    ReadFile = left$(strResult, Len(strResult) - 2)
    
    Close #ptr
    
    Exit Function

ReadErr:
    
    ReadFile = ""

End Function

Public Function WriteFile(ByVal strFileName As String, _
                          ByVal strWriteString As String, _
                          Optional F_WriteOption As Long = 0) As Boolean
'************************************************************************************************
'   Լ      :   WritFile
'   ۼ      :   
'   ۼ      :   2002.1.21
'   Ѽ  :   
'   μ        :   strFileName     -  ϸ
'                   strWriteString  -  Ʈ
'                   F_WriteOption   - Lock
'   ϰ      :   Boolean
'************************************************************************************************
Dim ptr As String
On Error GoTo WriteErr:
    
    ptr = FreeFile
    
    If F_WriteOption = 0 Then
        Open strFileName For Output As #ptr
        Print #ptr, strWriteString
    Else
        Open strFileName For Output Lock Write As #ptr
        Print #ptr, strWriteString
    End If
    
    Close #ptr
    WriteFile = True
    
    Exit Function
    
WriteErr:

    Close #ptr
    WriteFile = False

End Function

Public Function AppendFile(ByVal strFileName As String, _
                           ByVal strAppendString As String) As Boolean
'************************************************************************************************
'   Լ      :   AppendFile
'   ۼ      :   
'   ۼ      :   2002.1.21
'   Ѽ  :    ̱
'   μ        :   strFileName     -  ϸ
'                   strAppendString -  Ʈ
'   ϰ      :   Boolean
'************************************************************************************************
On Error GoTo AppendFileErr
Dim ptr As String
    
    ptr = FreeFile
    
    Open strFileName For Append As #ptr
        Print #ptr, strAppendString
    Close #ptr
    
    AppendFile = True
    
    Exit Function
    
AppendFileErr:

    AppendFile = False

End Function

Public Function GetFileAttr(ByVal strFileName As String) As Long
'************************************************************************************************
'   Լ      :   GetFileAttr
'   ۼ      :   
'   ۼ      :   2002.1.21
'   Ѽ  :    Ӽ ȯѴ.
'   μ        :   strFileName     - ϸ
'   ϰ      :   Long
'************************************************************************************************
Dim ret As Long
    
    GetFileAttr = GetFileAttributes(strFileName)

End Function

Public Function SetFileAttr(ByVal strFileName As String, _
                            ByVal LFileAttr As Long) As Boolean
'************************************************************************************************
'   Լ      :   SetFileAttr
'   ۼ      :   
'   ۼ      :   2002.1.21
'   Ѽ  :    Ӽ Ѵ.
'   μ        :   strFileName     - ϸ
'                   LFileAttr       -   Ӽ
'   ϰ      :   Boolean
'************************************************************************************************
    If SetFileAttributes(strFileName, LFileAttr) = 1 Then
        SetFileAttr = True
    End If

End Function

Public Function GetCreateTime(ByVal strFileName As String) As String
'************************************************************************************************
'   Լ      :   GetCreateTime
'   ۼ      :   
'   ۼ      :   2002.1.21
'
'   Ѽ  :   ϸð..
'
'
'   μ        :   strFileName     - ˻ ϸ
'   ϰ      :   string
'************************************************************************************************
Dim ipFindFileData  As WIN32_FIND_DATA
Dim hFindFirst      As Long
Dim FT              As FILETIME
Dim st              As SYSTEMTIME

On Error GoTo GetCreateTime
    
    hFindFirst = FindFirstFile(strFileName, ipFindFileData)
    
    If hFindFirst <> -1 Then
        Call FileTimeToLocalFileTime(ipFindFileData.ftLastWriteTime, FT)
        Call FileTimeToSystemTime(FT, st)
        GetCreateTime = st.wYear & "" & st.wMonth & "" & st.wDay & "" & st.wHour & "" & st.wMinute & ""
    End If
    
    Call FindClose(hFindFirst)
    
    Exit Function
    
GetCreateTime:

    GetCreateTime = ""
    
End Function

Public Function DelFile(ByVal strFileName As String) As Boolean
'************************************************************************************************
'   Լ      :   DelFile
'   ۼ      :   
'   ۼ      :   2002.1.21
'
'   Ѽ  :    Ѵ.
'                   "*" 
'                      FileDelete Event ߻,
'                   FileDelete Event  F_Cancel = True  ϵǸ  Ѵ.
'                   Ӽ   ....
'                      Լ ....
'
'   μ        :   strFileName     -  ϸ
'   ϰ      :   Boolean
'************************************************************************************************


    Dim ArrTemp()   As String
    Dim strPath     As String
    Dim i           As Long
    Dim F_Cancel    As Boolean
        
    Dim strFile() As String
    Dim blnRet      As Boolean
    
On Error GoTo ErrHnd

    If Trim(strFileName) = "" Then Exit Function
    If right(Trim(strFileName), 2) = ":\" Then Exit Function
    If Len(Trim(strFileName)) <= 3 Then Exit Function
        
    blnRet = SearchFile(strFileName, strFile())
    If Len(Join(strFile(), "\")) <= 0 Then Exit Function
    
    strPath = left$(strFileName, InStrRev(strFileName, "\") - 1)
    
    strFileName = Trim(strFileName)
    If strFileName = "*.*" Or strFileName = "\*.*" Then Exit Function
    
    If SearchFile(strFileName, ArrTemp) Then
        DelFile = True
        
        For i = 0 To UBound(ArrTemp, 1)
            If GetFileAttributes(strPath & "\" & ArrTemp(i)) <> FILE_ATTRIBUTE_NORMAL Then
                Call SetFileAttributes(strPath & "\" & ArrTemp(i), FILE_ATTRIBUTE_NORMAL)
            End If
            
            If DeleteFile(strPath & "\" & ArrTemp(i)) = 1 Then
                RaiseEvent FileDelete(ArrTemp(i), F_Cancel)
                
                If F_Cancel Then
                    DelFile = False
                    Exit For
                End If
            Else
                DelFile = False
                Exit For
            End If
        Next i
    End If
    Exit Function
    
ErrHnd:
    MsgBox "File class DelFile error!!", vbCritical + vbOKOnly, "Ȯ"
    
End Function

Public Function Copy_File(ByVal strSrcFileName As String, _
                          ByVal strDstFileName As String, _
                          Optional ByVal F_OverWrite As Boolean = True) As Boolean
'************************************************************************************************
'   Լ      :   Copy_File
'   ۼ      :   
'   ۼ      :   2002.1.21
'
'   Ѽ  :    Ѵ.
'                   "*" ,
'                   "*" ڰ ԵǴ   ϸ  "\" Ʈ ؾѴ.
'
'                   Ex : Copy_File(g_AppPath & "\*.*",g_AppPath & "\Temp\")
'                        Copy_File(g_AppPath & "\aaa.txt",g_AppPath & "\Temp\aaa.txt")
'
'                      FileCopy Event ߻,
'                   FileCopy Event  F_Cancel = True  ϵǸ 縦 Ѵ.
'                   翡   Լ ....
'
'   μ        :   strSrcFileName  -  ϸ
'                   strDstFileName  -  ϸ
'                   F_OverWrite     -  
'   ϰ      :   Boolean
'************************************************************************************************
    Dim ArrTemp()       As String
    Dim strSrcFilePath  As String
    Dim strDstFilePath  As String
    Dim LOverWrite      As Long
    Dim i               As Long
    Dim F_Cancel        As Boolean
    
    If Not F_OverWrite Then LOverWrite = 1
    strSrcFilePath = left$(strSrcFileName, InStrRev(strSrcFileName, "\") - 1)
    
    If right$(strDstFileName, 1) = "\" Then
        strDstFilePath = left$(strDstFileName, InStrRev(strDstFileName, "\") - 1)
        If SearchFile(strSrcFileName, ArrTemp) Then
            Copy_File = True
            
            For i = 0 To UBound(ArrTemp, 1)
                If CopyFile(strSrcFilePath & "\" & ArrTemp(i), _
                            strDstFilePath & "\" & ArrTemp(i), _
                            LOverWrite) = 1 Then
                    RaiseEvent FileCopy(ArrTemp(i), F_Cancel)
                Else
                    Copy_File = False
                    Exit For
                End If
            Next i
        End If
    Else
        Copy_File = True
        If CopyFile(strSrcFileName, strDstFileName, LOverWrite) = 1 Then
            RaiseEvent FileCopy(strSrcFileName, F_Cancel)
        Else
            Copy_File = False
        End If
    End If
    
End Function

Public Function CopyFolder(ByVal strSrcDirName As String, _
                           ByVal strDstDirName As String, _
                           Optional ByVal F_OverWrite As Boolean = True) As Boolean
'************************************************************************************************
'   Լ      :   CopyFolder
'   ۼ      :   
'   ۼ      :   2002.1.21
'
'   Ѽ  :    Ѵ.
'                      FileCopy Event ߻,
'                   FileCopy Event  F_Cancel = True  ϵǸ 縦 Ѵ.
'
'   μ        :   strSrcDirName   -  ͸
'                   strDstDirName   -  ͸
'                   F_OverWrite     - ⿩..
'   ϰ      :   Boolean
'************************************************************************************************
    Dim ipFindFileData  As WIN32_FIND_DATA
    Dim strSearchData   As String
    Dim strPath         As String
    Dim hFindFirst      As Long
    Dim LOverWrite      As Long
    Dim F_Cancel        As Boolean
    
    CopyFolder = True
    If Not F_OverWrite Then LOverWrite = 1
    strPath = strDstDirName & "\" & right$(strSrcDirName, Len(strSrcDirName) - InStrRev(strSrcDirName, "\"))
    Call CreateFolder(strPath)
    hFindFirst = FindFirstFile(strSrcDirName & "\*.*", ipFindFileData)
    
    If hFindFirst <> -1 Then
        Do
            strSearchData = StripNull(ipFindFileData.cFileName)
            
            If Not (strSearchData = "." Or strSearchData = "..") _
               And (GetAttr(strSrcDirName & "\" & strSearchData) And vbDirectory) <> vbDirectory Then
                If CopyFile(strSrcDirName & "\" & strSearchData, strPath & "\" & strSearchData, LOverWrite) Then
                    RaiseEvent FileCopy(strSearchData, F_Cancel)
                    
                    If F_Cancel Then
                        CopyFolder = False
                        Exit Do
                    End If
                    
                    DoEvents
                Else
                    CopyFolder = False
                    Exit Do
                End If
            ElseIf Not (strSearchData = "." Or strSearchData = "..") _
                   And (GetAttr(strSrcDirName & "\" & strSearchData) And vbDirectory) = vbDirectory Then
                If CopyFolder(strSrcDirName & "\" & strSearchData, strPath, F_OverWrite) Then
                    RaiseEvent FileCopy(strSearchData, F_Cancel)
                    If F_Cancel Then
                        CopyFolder = False
                        Exit Do
                    End If
                Else
                    CopyFolder = False
                    Exit Do
                End If
            End If
        Loop While FindNextFile(hFindFirst, ipFindFileData)
    End If
    
    Call FindClose(hFindFirst)
    
End Function


Public Function SeekFile(ByVal strFileName As String) As Boolean
'************************************************************************************************
'   Լ      :   SeekFile
'   ۼ      :   
'   ۼ      :   2002.4.18
'
'   Ѽ  :   Ư  ˻Ѵ.
'
'   μ        :   strFileName     - ˻ ϸ
'   ϰ      :   Boolean
'************************************************************************************************
    Dim ipFindFileData  As WIN32_FIND_DATA
    Dim strSearchData   As String
    Dim strPath         As String
    Dim hFindFirst      As Long
    Dim LCnt            As Long
            
On Error GoTo SearChFileErr
    
    hFindFirst = FindFirstFile(strFileName, ipFindFileData)
    
    If hFindFirst <> -1 Then
        Do
            strSearchData = StripNull(ipFindFileData.cFileName)
            
            If Not (strSearchData = "." Or strSearchData = "..") _
               And (ipFindFileData.dwFileAttributes And vbDirectory) <> vbDirectory Then
                SeekFile = True
                Exit Do
            End If
        Loop While FindNextFile(hFindFirst, ipFindFileData)
    End If
    
    Call FindClose(hFindFirst)
    
    Exit Function
    
SearChFileErr:

End Function

Public Function SearchFolder(ByVal strDirPath As String, ArrResult() As String) As Boolean
'************************************************************************************************
'   Լ      :   SearchFolder
'   ۼ      :   
'   ۼ      :   2002.1.21
'
'   Ѽ  :   ͸ ˻Ѵ.
'                   "*"  
'                   ˻ ͸ 迭 Ѵ.
'
'   μ        :   strDirPath      - ˻ ͸
'                   ArrResult       - ˻ ͸  迭..
'   ϰ      :   Boolean
'************************************************************************************************

    Dim ipFindFileData  As WIN32_FIND_DATA
    Dim strSearchData   As String
    Dim strStartPath    As String
    Dim strPath         As String
    Dim hFindFirst      As Long
    Dim LCnt            As Long

On Error GoTo SearchFolderErr

    ArrResult = Split("", "|")
    LCnt = -1
    strPath = strDirPath

    If right$(strDirPath, 1) = "\" Then
        strStartPath = strDirPath & "*"
    Else
        strStartPath = strDirPath & "\*"
    End If

    hFindFirst = FindFirstFile(strStartPath, ipFindFileData)

    If hFindFirst <> -1 Then
        Do
            strSearchData = StripNull(ipFindFileData.cFileName)

            If Not (strSearchData = "." Or strSearchData = "..") _
               And (ipFindFileData.dwFileAttributes And vbDirectory) = vbDirectory Then
                LCnt = LCnt + 1
                ReDim Preserve ArrResult(LCnt)
                ArrResult(LCnt) = strSearchData
            End If
        Loop While FindNextFile(hFindFirst, ipFindFileData)
    End If

    Call FindClose(hFindFirst)
    Call QuickSort(ArrResult, 0, UBound(ArrResult, 1))

    If UBound(ArrResult, 1) >= 0 Then
        SearchFolder = True
    End If

    Exit Function



SearchFolderErr:

    Call FindClose(hFindFirst)
    ArrResult = Split("", "|")
    
End Function

Public Function DepthSearch(ByVal strFilePath As String, _
                            ByVal strFileFormat As String, _
                            ArrFileName() As String) As Boolean
'************************************************************************************************
'   Լ      :   DepthSearch
'   ۼ      :   
'   ۼ      :   2002.1.21
'
'   Ѽ  :    ͸ Ưϸ ˻Ѵ.
'                   "*"  
'                   ˻ ϸ Full-Path 迭 Ѵ.
'
'   μ        :   strFilePath     - ˻ ͸
'                   strFileFormat   - ˻  Format
'                   ArrFileName     - ϵ ϸ迭
'   ϰ      :   Boolean
'************************************************************************************************
    Dim ipFindFileData  As WIN32_FIND_DATA
    Dim strDirPath()    As String
    Dim strSearchData   As String
    Dim hFindFirst      As Long
    Dim i               As Long
    
    If Not CheckArray(ArrFileName) Then
        ArrFileName = Split("", "|")
    End If
   
    If right$(strFilePath, 1) = "\" Then strFilePath = left$(strFilePath, InStrRev(strFilePath, "\") - 1)
    Call SearchFolder(strFilePath, strDirPath)
    
    For i = 0 To UBound(strDirPath, 1)
        Call DepthSearch(strFilePath & "\" & strDirPath(i), strFileFormat, ArrFileName)
    Next i
    
    hFindFirst = FindFirstFile(strFilePath & "\" & strFileFormat, ipFindFileData)
    
    If hFindFirst <> -1 Then
        Do
            strSearchData = StripNull(ipFindFileData.cFileName)
            
            If Not (strSearchData = "." Or strSearchData = "..") _
               And (ipFindFileData.dwFileAttributes And vbDirectory) <> vbDirectory Then
                ReDim Preserve ArrFileName(UBound(ArrFileName, 1) + 1)
                ArrFileName(UBound(ArrFileName, 1)) = strFilePath & "\" & strSearchData
            End If
        Loop While FindNextFile(hFindFirst, ipFindFileData)
    End If
    
    Call FindClose(hFindFirst)
    
    If UBound(ArrFileName, 1) >= 0 Then DepthSearch = True
    
End Function

Public Function RemoveFolder(ByVal strRemovePath As String) As Boolean
'************************************************************************************************
'   Լ      :   RemoveFolder
'   ۼ      :   
'   ۼ      :   2002.1.21
'
'   Ѽ  :   ͸ Ѵ.
'                      FileDelete Event ߻,
'                   FileDelete Event  F_Cancel = True  ϵǸ  Ѵ.
'                   Ӽ   ....
'                      Լ ....
'
'   μ        :   strRemovePath     -  ͸ 
'   ϰ      :   Boolean
'************************************************************************************************
    Dim ipFindFileData  As WIN32_FIND_DATA
    Dim strSearchData   As String
    Dim strPath         As String
    Dim hFindFirst      As Long
    Dim ret             As Long
    Dim F_Cancel        As Boolean
    Dim lngCnt          As Long

On Error GoTo ErrHnd

    '' 2006.04.05. 
    ''   üũ ߰/
    
    RemoveFolder = False
    
    If Trim(strRemovePath) = "" Then Exit Function
    If right(Trim(strRemovePath), 2) = ":\" Then Exit Function
    If Len(Trim(strRemovePath)) <= 3 Then Exit Function
    
    Do
        If right$(strRemovePath, 1) = "\" Then
            strRemovePath = left$(strRemovePath, (Len(strRemovePath) - 1))
        Else
            Exit Do
        End If
    Loop
    
    '' ϰϴ ΰ , Exit
    If IsFolderExists(strRemovePath) = False Then Exit Function
    
    
    hFindFirst = FindFirstFile(strRemovePath & "\*.*", ipFindFileData)
    If right(strRemovePath, 2) = ":\" Then Exit Function
    
    If hFindFirst <> -1 Then
        Do
            strSearchData = StripNull(ipFindFileData.cFileName)
            
            If Not (strSearchData = "." Or strSearchData = "..") _
               And (GetAttr(strRemovePath & "\" & strSearchData) And vbDirectory) <> vbDirectory Then
                
                If GetFileAttributes(strRemovePath & "\" & strSearchData) <> FILE_ATTRIBUTE_NORMAL Then
                    Call SetFileAttributes(strRemovePath & "\" & strSearchData, FILE_ATTRIBUTE_NORMAL)
                End If
                
                If DeleteFile(strRemovePath & "\" & strSearchData) = 1 Then
                    RaiseEvent FileDelete(strSearchData, F_Cancel)
                    If F_Cancel Then Exit Do
                    RemoveFolder = True
                Else
                    Exit Do
                End If
            ElseIf Not (strSearchData = "." Or strSearchData = "..") _
                   And (GetAttr(strRemovePath & "\" & strSearchData) And vbDirectory) = vbDirectory Then
             
                If RemoveFolder(strRemovePath & "\" & strSearchData) Then
                    RemoveFolder = True
                Else
                    Exit Do
                End If
                
            End If
            DoEvents
        Loop While FindNextFile(hFindFirst, ipFindFileData)
    End If
    
    Call FindClose(hFindFirst)
       
    If GetFileAttributes(strRemovePath) <> FILE_ATTRIBUTE_NORMAL Then
        Call SetFileAttributes(strRemovePath, FILE_ATTRIBUTE_NORMAL)
    End If
       
    If RemoveDirectory(strRemovePath) = 1 Then RemoveFolder = True
    Exit Function
    
ErrHnd:
    MsgBox "File class RemoveFolder error!!", vbCritical + vbOKOnly, "Ȯ"
    
End Function

'****************************************************************************************************CS
'   Լ      :   QuickSort
'   ۼ      :   ȣ
'   ۼ      :   2002.1.21
'
'   Ѽ  :   迭 SortŲ..
'
'   μ        :   strData     - ߶ ڿ
'                   SortArray   - Sort 迭
'                   Low         - Sortų ּ ε
'                   High        - Sortų ִ ε
'   ϰ      :   
'************************************************************************************************
Public Sub QuickSort(SortArray() As String, _
                      ByVal Low As Long, _
                      ByVal High As Long)
    

    
    Dim Partition       As String
    Dim RandIndex       As Long
    Dim i               As Long
    Dim j               As Long
    
    If Low < High Then
        
        If High - Low = 1 Then
            
            If UCase(SortArray(Low)) > UCase(SortArray(High)) Then
                
                Call SWAP(SortArray(Low), SortArray(High))
            
            End If
        
        Else
            
            RandIndex = Rnd() * (High - Low) + Low
            
            Call SWAP(SortArray(High), SortArray(RandIndex))
            Partition = UCase(SortArray(High))
            
            i = Low: j = High
            
            Do
                
                Do While (i < j) And (UCase(SortArray(i)) <= Partition)
                    i = i + 1
                Loop
                
                Do While (j > i) And (UCase(SortArray(j)) >= Partition)
                    j = j - 1
                Loop
                
                If i < j Then
                    Call SWAP(SortArray(i), SortArray(j))
                End If
                DoEvents
            Loop While i < j
            
            
            Call SWAP(SortArray(i), SortArray(High))
            
            If (i - Low) < (High - i) Then
            
                Call QuickSort(SortArray, Low, i - 1)
                Call QuickSort(SortArray, i + 1, High)
            
            Else
                Call QuickSort(SortArray, i + 1, High)
                Call QuickSort(SortArray, Low, i - 1)
            End If
            
        End If
        
    End If
    
End Sub

'****************************************************************************************************CS
'   Լ      :   SWAP
'   ۼ      :   ȣ
'   ۼ      :   2002.1.21
'
'   Ѽ  :    ͸ ȯѴ.
'
'   μ        :   strFirst    - ȯ ù° ڿ
'                   strSecond   - ȯ ι° ڿ
'   ϰ      :   
'************************************************************************************************
Private Sub SWAP(strFirst As String, strSecond As String)


    Dim strTemp As String
    
    strTemp = strFirst
    
    strFirst = strSecond
    strSecond = strTemp

End Sub


Private Function CheckArray(ArrTemp() As String) As Boolean

    Dim i As Long

On Error GoTo CheckArrayError

    i = UBound(ArrTemp, 1)
    CheckArray = True

    Exit Function

CheckArrayError:

End Function

Public Sub GetDiskSpace(ByVal strDrive As String, _
                        LTotalBytes As Double, _
                        LFreeBytes As Double)
'************************************************************************************************
'   Լ      :   GetDiskSpace
'   ۼ      :   
'   ۼ      :   2002.3.21
'
'   Ѽ  :   ũ  Ѵ.
'
'   μ        :   strDrive        - ̺ 
'                   LTotalBytes     - ü̺ Ʈ 
'                   LFreeBytes      - Ҽ ִ Ʈ 
'   ϰ      :   
'************************************************************************************************
    Dim lFreeBytesToCallers As Currency
    Dim LTot                As Currency
    Dim LFree               As Currency
    Dim lRet                As Long
    
    lRet = GetDiskFreeSpaceEx(strDrive, lFreeBytesToCallers, LTot, LFree)
    LTotalBytes = CDbl(LTot * 10000)
    LFreeBytes = CDbl(LFree * 10000)

End Sub

Private Sub DepthFileSizeSearch(ByVal strStartPath As String, _
                                ByVal strSearchFileFormat As String, _
                                DFileLen As Double)
    ' Ž
    Dim strDirPath()    As String
    Dim strFileName()   As String
    Dim i               As Long
    Dim j               As Long
    
    If right$(strStartPath, 1) = "\" Then strStartPath = left$(strStartPath, 2)
    Call SearchFolder(strStartPath, strDirPath)
    
    For i = 0 To UBound(strDirPath, 1)
        Call DepthFileSizeSearch(strStartPath & "\" & strDirPath(i), strSearchFileFormat, DFileLen)
    Next i
    
    Call AddSearchFileSize(strStartPath & "\" & strSearchFileFormat, DFileLen)
    
End Sub

Public Function AddSearchFileSize(ByVal strFullPath As String, _
                                  DFileLen As Double) As String
    '  Ѵ.
    Dim ipFindFileData  As WIN32_FIND_DATA
    Dim hFindFirst      As Long
    Dim temp            As String
    Dim str             As String
            
On Error Resume Next
    
    hFindFirst = FindFirstFile(strFullPath, ipFindFileData)               'ϪO 
    
    If hFindFirst <> -1 Then
        Do
            temp = StripNull(ipFindFileData.cFileName)
            
            If Not (temp = "." Or temp = "..") And _
                    (ipFindFileData.dwFileAttributes And 16) <> 16 Then
                DFileLen = DFileLen + ipFindFileData.nFileSizeLow
            End If
        Loop While FindNextFile(hFindFirst, ipFindFileData)             ' O´.
    End If
    
    Call FindClose(hFindFirst)
    
End Function


Public Function GetFolderSize(ByVal strPath As String, _
                              ByVal strFileFormat As String) As Double
'************************************************************************************************
'   Լ      :   GetFolderSize
'   ۼ      :   
'   ۼ      :   2002.4.21
'
'   Ѽ  :   Ư   Ѵ.
'
'   μ        :   strPath         -   
'                   strFileFormat   -     Ѵ.
'                                      Ư  Tif  ҷ *.tif
'                                     ü  ҷ *.*  ָ ȴ.. ^^
'   ϰ      :   Double -->  Ѵ.
'************************************************************************************************
Dim DFileLen        As Double
    
    Call DepthFileSizeSearch(strPath, strFileFormat, DFileLen)
    GetFolderSize = DFileLen
       
End Function



Public Function CheckFolder(ByVal strPath As String, ByVal strFolderName As String) As Boolean
'****************************************************************************************************CS
'   Լ      :   CheckFolder
'   ۼ      :
'   ۼ      :   2002.05.03
'
'   Ѽ  :   ش  ϴ ˻Ѵ.
'               :
'               :
'
'   μ        :   ˻ 丮, 
'   ϰ      :   Boolean
'****************************************************************************************************CE
    Dim i As Long
    Dim arrFolder() As String
    
    CheckFolder = False
    
    arrFolder = Split(SearchDir(strPath & "\*.*"), "|")
    
    For i = 0 To UBound(arrFolder, 1)
        If strFolderName = arrFolder(i) Then
            CheckFolder = True
            Exit Function
        End If
    Next i
    
End Function

Public Function SearchDir(ByVal FullPath As String) As String
    Dim ipFindFileData As WIN32_FIND_DATA
    Dim hFindFirst As Long
    Dim temp As String
    Dim str As String
    
On Error Resume Next
    
    hFindFirst = FindFirstFile(FullPath, ipFindFileData)               'ã 
    
    If hFindFirst <> -1 Then
        Do
            temp = StripNull(ipFindFileData.cFileName)
            
            If Not (temp = "." Or temp = "..") And _
                    (ipFindFileData.dwFileAttributes = 17 Or ipFindFileData.dwFileAttributes = 16 _
                    Or ipFindFileData.dwFileAttributes = 48 Or ipFindFileData.dwFileAttributes = 49) Then
                str = str & temp & "|"
            End If
        Loop While FindNextFile(hFindFirst, ipFindFileData)             ' ã´.
    
        Call FindClose(hFindFirst)
    End If
        
    SearchDir = SortFile(str)
    
End Function


Public Function SortFile(ByVal str As String) As String
    Dim strArray() As String
    Dim temp As String
    Dim i As Integer
    Dim j As Integer
    
    If str <> "" Then
        str = left$(str, Len(str) - 1)
        strArray = Split(str, "|")
        
        For i = 0 To UBound(strArray, 1)
            For j = i + 1 To UBound(strArray, 1)
                If strArray(j) < strArray(i) Then
                    temp = strArray(j)
                    strArray(j) = strArray(i)
                    strArray(i) = temp
                End If
            Next j
        Next i
        
        str = ""
        
        For i = 0 To UBound(strArray, 1)
            str = str & strArray(i) & "|"
        Next i
        
        SortFile = left(str, Len(str) - 1)
    End If

End Function

Public Function CreateFolder(ByVal strFolderName As String) As Boolean
'************************************************************************************************
'   Լ      :   CreateFolder
'   ۼ      :   ȣ
'   ۼ      :   2002.1.21
'   Ѽ  :   ͸ Ѵ.
'   μ        :   strFolderName     -  
'   ϰ      :   Boolean
'************************************************************************************************
    Dim lpSecurityAttributes    As SECURITY_ATTRIBUTES
    Dim ret                     As Long
    
    ret = CreateDirectoryEx(App.Path, strFolderName, lpSecurityAttributes)
    If ret = 1 Then CreateFolder = True

End Function

'****************************************************************************************************CS
'   Լ      :   FileReadcol
'   ۼ      :   
'   ۼ      :   2002.06.11
'
'   Ѽ  :
'               :
'               :
'
'   μ        :
'   ϰ      :
'****************************************************************************************************CE
Public Function FileReadcol(ByVal Filename As String, ByVal F_Mode As Long) As String
'*********************************************************************************************************************************
'                       ReadFile( F_Mode --> 0(Nomal) , 1(Lock))
'*********************************************************************************************************************************
    Dim Result As String
    Dim text As String
    Dim ptr As String
    
    
On Error GoTo ReadErr:
    
    ptr = FreeFile
       
    If F_Mode = 0 Then
        
        Open Filename For Input As #ptr
        Do Until EOF(ptr)
            Input #ptr, text
            Result = Result & text & "|"
        Loop
    
    Else
        
        Open Filename For Input Lock Read As #ptr
        Do Until EOF(ptr)
            Input #ptr, text
            Result = Result & text & "|"
        Loop
    
    End If
    
   
    
    FileReadcol = left$(Result, Len(Result) - 1)
    
    Close
    Exit Function

ReadErr:
    
    FileReadcol = ""

End Function


Function ParseString(ByVal StrIn As String, StrOut() As String, Optional Delimiter As Variant) As Integer
'****************************************************************************************************CS
'   Լ      :   ParseString
'   ۼ      :
'   ۼ      :   2002.05.08
'
'   Ѽ  :
'               :
'               :
'
'   μ        :
'   ϰ      :
'****************************************************************************************************CE
   Dim InElement As Boolean
   Dim NumEls As Integer
   Dim nPos As Long
   Dim Char As String
   Dim Delimit As String
   
   If Not IsMissing(Delimiter) Then
      If Len(Delimiter) Then
         Delimit = left(Delimiter, 1)
      End If
   End If
   InElement = False
   For nPos = 1 To Len(StrIn)
      Char = Mid(StrIn, nPos, 1)
      If Char <> Delimit Then
         If Not InElement Then
            InElement = True
            NumEls = NumEls + 1
            ReDim Preserve StrOut(0 To NumEls - 1)
         End If
         StrOut(NumEls - 1) = StrOut(NumEls - 1) & Char
      Else
        If InElement = False Then
            NumEls = NumEls + 1
            ReDim Preserve StrOut(0 To NumEls - 1)
            StrOut(NumEls - 1) = StrOut(NumEls - 1) & " "
        Else
            InElement = False
        End If
      End If
   Next nPos
   ParseString = NumEls
   
End Function

Public Sub FileWrite(ByVal Filename As String, ByVal FileString As String)
    Dim F As Integer
    Dim strTemp As String
    
    Dim i As String
    
    F = FreeFile()
    
    Open Filename For Output As F
    Print #F, FileString
    Close F
    
End Sub

Public Function FileLoad(ByVal Filename As String) As String
    Dim F As Integer
    Dim strTemp As String
    
    Dim i As String
    
    F = FreeFile()
  
    Open Filename For Binary As F
    strTemp = Input(LOF(F), F)
    Close F
    If strTemp <> "" Then
        If Trim(strTemp) <> "" Then
            FileLoad = Trim(strTemp)
        Else
            FileLoad = "0"
        End If
    Else
        FileLoad = "0"
    End If
End Function

Public Function SaveToFile(ByVal strFile As String, strLines() As String) As Boolean
  Dim nFnum As Integer
  Dim nIndex As Integer
  Dim nCount As Integer
  
  nFnum = FreeFile
  
  nCount = UBound(strLines)
  
  Open strFile For Output As #nFnum
  
  For nIndex = 1 To nCount
    Print #nFnum, strLines(nIndex)
  Next nIndex
    
  Close #nFnum
  
  SaveToFile = True
End Function

Public Function WriteLogToFile(ByVal strFile As String, ByVal strMsg As String) As Boolean
  Dim nFnum As Integer
  Dim strLine As String
  
  WriteLogToFile = False
  nFnum = FreeFile
  
  strLine = "[" & Format(Now, "YY.MM.DD HH:MM:SS") & "] " & vbTab & strMsg
  
  Open strFile For Append As #nFnum
    Print #nFnum, strLine
  Close #nFnum
  
  WriteLogToFile = True
End Function

Public Function LoadFromFile(ByVal strFile As String, strLines() As String) As Integer
  Dim nIndex As Integer
  Dim nCount As String
  Dim nFnum As Integer
  Dim strLine As String
  
  nFnum = FreeFile
  
  Open strFile For Input As #nFnum
  nIndex = 0
  Do While Not EOF(nFnum)   '   ݺմϴ.
     Input #nFnum, strLine
     
     nIndex = nIndex + 1
     ReDim Preserve strLines(1 To nIndex)
     strLines(nIndex) = strLine
  Loop
  Close #nFnum
  LoadFromFile = nIndex
End Function



Public Function IniRead(ByVal SectionName As String, ByVal KeyName As String, ByVal IniFileName As String) As String
'' =================================================
'' INI Ͽ  д´.
'' =================================================
''   Ÿ : String

    Dim lngRet          As Long
    Dim strRet          As String
    
    
    If Trim(SectionName) = "" Then Exit Function
    If Trim(KeyName) = "" Then Exit Function
    If Trim(IniFileName) = "" Then Exit Function
    
    strRet = String(255, 0)
    
    lngRet = GetPrivateProfileString(SectionName, KeyName, "", strRet, Len(strRet), IniFileName)
    If lngRet > 0 Then
        IniRead = StripNull(strRet)
    Else
        IniRead = ""
    End If
        
End Function


Public Function IniWrite(ByVal SectionName As String, ByVal KeyName As String, ByVal WriteData As String, ByVal IniFileName As String) As Long
'' =================================================
'' INI Ͽ  
'' =================================================
''   Ÿ : Long

    'If Trim(SectionName) = "" Then Exit Function
    If Trim(KeyName) = "" Then Exit Function
    If Trim(IniFileName) = "" Then Exit Function
    
    IniWrite = WritePrivateProfileString(SectionName, KeyName, WriteData, IniFileName)

End Function

Public Function IsFileExists(ByVal strFile As String) As Boolean
  Dim strDirResult As String
  
  IsFileExists = False
  strDirResult = Dir(strFile)
  
  If Len(Trim(strDirResult)) > 0 Then
    IsFileExists = True
  End If
End Function

Public Function IsFolderExists(ByVal strFile As String) As Boolean

  Dim strDirResult As String
  
  IsFolderExists = False
  strDirResult = Dir(strFile, vbDirectory)
  
  If Len(Trim(strDirResult)) > 0 Then
    IsFolderExists = True
  End If
  
End Function

Public Function FoldersInFolder(ByVal strFolder As String, strFolders() As String) As Long

  Dim ipFindFileData As WIN32_FIND_DATA
  Dim hFindFirst As Long
  Dim strName As String
  Dim nIndex As Integer
  Dim strSearchFolder As String
  
  strSearchFolder = IIf(right(strFolder, 1) = "\", strFolder, strFolder + "\") + "*.*"
  
  hFindFirst = FindFirstFile(strSearchFolder, ipFindFileData)               'ϪO 
  If hFindFirst <> -1 Then
    nIndex = 0
    Do
      strName = StripNull(ipFindFileData.cFileName)
      If (Not (strName = "." Or strName = "..")) And ((ipFindFileData.dwFileAttributes And FILE_ATTRIBUTE_DIRECTORY) = FILE_ATTRIBUTE_DIRECTORY) Then
        nIndex = nIndex + 1
        ReDim Preserve strFolders(1 To nIndex)
        strFolders(nIndex) = strName
      End If
    Loop While FindNextFile(hFindFirst, ipFindFileData)             ' O´.
  End If
  
  Call FindClose(hFindFirst)
  
  FoldersInFolder = nIndex
  
End Function

Public Function FilesInFolder(ByVal strFolder As String, strFiles() As String) As Long

  Dim ipFindFileData As WIN32_FIND_DATA
  Dim hFindFirst As Long
  Dim strName As String
  Dim nIndex As Integer
  
  hFindFirst = FindFirstFile(strFolder, ipFindFileData)               'ϪO 
  If hFindFirst <> -1 Then
    nIndex = 0
    Do
      strName = StripNull(ipFindFileData.cFileName)
      If (Not (strName = "." Or strName = "..")) And ((ipFindFileData.dwFileAttributes And FILE_ATTRIBUTE_DIRECTORY) <> FILE_ATTRIBUTE_DIRECTORY) Then
        nIndex = nIndex + 1
        ReDim Preserve strFiles(1 To nIndex)
        strFiles(nIndex) = strName
      End If
    Loop While FindNextFile(hFindFirst, ipFindFileData)             ' O´.
  End If
  
  Call FindClose(hFindFirst)
  
  FilesInFolder = nIndex
End Function

Public Function SHCopyFile(hWnd As Long, ByVal FileSource As String, ByVal FileDestination As String) As Long

On Error GoTo SHCOPY_FILE_ERROR
  Dim lResult As Long
  Dim FileOp As SHFILEOPSTRCT
  Dim lSuccess As Long
  
  DoEvents
  With FileOp
    .hWnd = hWnd
    .wfunc = FO_COPY
    .pfrom = FileSource & vbNullChar & vbNullChar
    .pto = FileDestination & vbNullChar & vbNullChar

    .fFlags = FOF_FILESONLY Or FOF_ALLOWUNDO Or FOF_CREATEPROGRESSDLG Or FOF_NOCONFIRMMKDIR
  End With
    
  lSuccess = 0
  lResult = SHFileOperation(FileOp)
  
  If lResult <> 0 Then
    'MsgBox Err.LastDllError, vbOKOnly, "ȭ  "
    lSuccess = -1
  Else
    If FileOp.fAnyOperationsAborted <> 0 Then
      'MsgBox "ȭ  ", vbOKOnly, "ȭ  "
      lSuccess = -1
    End If
  End If
  
  SHCopyFile = lSuccess
  
On Error GoTo 0
Exit Function
SHCOPY_FILE_ERROR:
On Error GoTo 0

End Function

Public Function SHMoveFile(hWnd As Long, ByVal FileSource As String, ByVal FileDestination As String) As Long
  Dim lResult As Long
  Dim FileOp As SHFILEOPSTRCT
      
  DoEvents
  With FileOp
    .hWnd = hWnd
    .wfunc = FO_MOVE
    .pfrom = FileSource & vbNullChar & vbNullChar
    .pto = FileDestination & vbNullChar & vbNullChar

    .fFlags = FOF_FILESONLY Or FOF_ALLOWUNDO Or FOF_CREATEPROGRESSDLG Or FOF_NOCONFIRMMKDIR Or FOF_NOCONFIRMATION
  End With
    
  DoEvents
  lResult = SHFileOperation(FileOp)
  DoEvents
  
  If lResult <> 0 Then
    MsgBox Err.LastDllError, vbOKOnly, "ȭ  "
  Else
    If FileOp.fAnyOperationsAborted <> 0 Then
      MsgBox "ȭ  ", vbOKOnly, "ȭ  "
    End If
  End If
End Function


Public Function SHDeleteFile(hWnd As Long, ByVal FileSource As String) As Long
  Dim lResult As Long
  Dim FileOp As SHFILEOPSTRCT
      
  DoEvents
  With FileOp
    .hWnd = hWnd
    .wfunc = FO_DELETE
    .pfrom = FileSource & vbNullChar & vbNullChar

    .fFlags = FOF_FILESONLY Or FOF_ALLOWUNDO Or FOF_CREATEPROGRESSDLG Or FOF_NOCONFIRMATION
  End With
    
  DoEvents
  lResult = SHFileOperation(FileOp)
  DoEvents
  
  If lResult <> 0 Then
    MsgBox Err.LastDllError, vbOKOnly, "ȭ  "
  Else
    If FileOp.fAnyOperationsAborted <> 0 Then
      MsgBox "ȭ  ", vbOKOnly, "ȭ  "
    End If
  End If
End Function

Public Function SHRenameFile(hWnd As Long, ByVal FileSource As String, ByVal FileDestination As String) As Long
  Dim lResult As Long
  Dim FileOp As SHFILEOPSTRCT
      
  DoEvents
  With FileOp
    .hWnd = hWnd
    .wfunc = FO_RENAME
    .pfrom = FileSource & vbNullChar & vbNullChar
    .pto = FileDestination & vbNullChar & vbNullChar

    .fFlags = FOF_FILESONLY Or FOF_ALLOWUNDO Or FOF_CREATEPROGRESSDLG Or FOF_NOCONFIRMMKDIR
  End With
    
  DoEvents
  lResult = SHFileOperation(FileOp)
  DoEvents
  
  If lResult <> 0 Then
    MsgBox Err.LastDllError, vbOKOnly, "ȭ  "
  Else
    If FileOp.fAnyOperationsAborted <> 0 Then
      MsgBox "ȭ  ", vbOKOnly, "ȭ  "
    End If
  End If
End Function

Public Function ExtractFileName(ByVal strFull As String, Optional bBase As Boolean) As String
  Dim strValues() As String
  Dim strName As String
  Dim bBaseOnly As Boolean
  
  bBaseOnly = IIf(IsMissing(bBase), False, bBase)
  
  strName = strFull + "\"
  strValues = Split(strName, "\")
  
  strName = ""
  strName = strValues(UBound(strValues) - 1)
  
  If bBaseOnly Then
    If InStr(1, strName, ".") > 0 Then
      strName = Mid(strName, 1, InStr(1, strName, ".") - 1)
    End If
  End If
  
  ExtractFileName = strName
End Function



Public Function SearchFile(ByVal strFileName As String, ArrResult() As String) As Boolean
'************************************************************************************************
'   Լ      :   SearchFile
'   ۼ      :   
'   ۼ      :   2002.1.21
'
'   Ѽ  :    ˻Ѵ.
'                   "*"  
'                   ˻ ϸ 迭 Ѵ.
'
'   μ        :   strFileName     - ˻ ϸ
'                   ArrResult       - ˻   迭..
'   ϰ      :   Boolean
'************************************************************************************************
    Dim ipFindFileData  As WIN32_FIND_DATA
    Dim strSearchData   As String
    Dim strPath         As String
    Dim hFindFirst      As Long
    Dim LCnt            As Long
            
On Error GoTo SearChFileErr
    
    ArrResult = Split("", "|")
    LCnt = -1

    strPath = left$(strFileName, InStrRev(strFileName, "\"))
    hFindFirst = FindFirstFile(strFileName, ipFindFileData)
    
    If hFindFirst <> -1 Then
        Do
            strSearchData = StripNull(ipFindFileData.cFileName)
            
            If Not (strSearchData = "." Or strSearchData = "..") _
               And (ipFindFileData.dwFileAttributes And vbDirectory) <> vbDirectory Then
                LCnt = LCnt + 1
                ReDim Preserve ArrResult(LCnt)
                ArrResult(LCnt) = strSearchData
            End If
        Loop While FindNextFile(hFindFirst, ipFindFileData)
    End If
    
    Call FindClose(hFindFirst)
    Call QuickSort(ArrResult, 0, UBound(ArrResult, 1))
    
    If UBound(ArrResult, 1) >= 0 Then
        SearchFile = True
    End If
    
    Exit Function
    
SearChFileErr:

    ArrResult = Split("", "|")
    
End Function

Public Function FolderINFilesCount(ByVal strFileName As String, ArrResult() As String) As Long
'************************************************************************************************
'   Լ      :   SearchFile
'   ۼ      :   
'   ۼ      :   2002.1.21
'
'   Ѽ  :    ˻ ϰ Ѵ.
'                   "*"  
'                   ˻ ϸ 迭 Ѵ.
'                    ϰ üũϰ  ο ϰ  ۵Ǿ ̷ Ѵ.
'   μ        :   strFileName     - ˻ ϸ
'                   ArrResult       - ˻   迭..
'   ϰ      :   Long
'************************************************************************************************
    Dim ipFindFileData  As WIN32_FIND_DATA
    Dim strSearchData   As String
    Dim strPath         As String
    Dim hFindFirst      As Long
    Dim LCnt            As Long
                
On Error GoTo SearChFileErr
    
    ArrResult = Split("", "|")
    LCnt = -1
    strPath = left$(strFileName, InStrRev(strFileName, "\"))
    hFindFirst = FindFirstFile(strFileName, ipFindFileData)
    
    If hFindFirst <> -1 Then
        Do
            strSearchData = StripNull(ipFindFileData.cFileName)
            
            If Not (strSearchData = "." Or strSearchData = "..") _
               And (ipFindFileData.dwFileAttributes And vbDirectory) <> vbDirectory Then
                LCnt = LCnt + 1
                ReDim Preserve ArrResult(LCnt)
                ArrResult(LCnt) = strSearchData
            End If
        Loop While FindNextFile(hFindFirst, ipFindFileData)
    End If
    
    Call FindClose(hFindFirst)
    Call QuickSort(ArrResult, 0, UBound(ArrResult, 1))
    
    If UBound(ArrResult, 1) >= 0 Then
        FolderINFilesCount = UBound(ArrResult, 1) + 1
    End If
    
    Exit Function
    
SearChFileErr:

    ArrResult = Split("", "|")
    
End Function




Public Function CopyOperation(hWnd As Long, ByVal srcFileName As String, ByVal DstPath As String) As Boolean

    
    Dim utdShellOpSTRCt As SHFILEOPSTRCT
    Dim lngReturnCode    As Long
    
    utdShellOpSTRCt.hWnd = hWnd
    utdShellOpSTRCt.wfunc = FO_COPY
    utdShellOpSTRCt.pfrom = srcFileName
    utdShellOpSTRCt.pto = DstPath
    
    lngReturnCode = SHFileOperation(utdShellOpSTRCt)
    
    If lngReturnCode = 0 Then CopyOperation = True
    
End Function





